
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Framerate","LEFT")
local btn = Glance.Buttons.Framerate
btn.text              = "Framerate"
btn.events            = {}
btn.update            = true
btn.tooltip           = true
btn.timer1            = true
btn.timerTooltip      = true

---------------------------
-- mod variables
---------------------------
Glance.Variables.party.a["Framerate"] = 0
Glance.Variables.party.b["Framerate"] = 0
Glance.Variables.party.c["Framerate"] = 0
Glance.Variables.party.d["Framerate"] = 0
Glance.Variables["fps"] = {
	["avg"] = 0,
	["current"] = 0,
	["min"] = 0,
	["max"] = 0,
	["count"] = 0,
}

---------------------------
-- update
---------------------------
function Glance.Functions.Framerate.update()
	local btn  = Glance.Buttons.Framerate
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		Glance.Functions.stats(Glance.Variables.fps,GetFramerate())
		btn.button:SetFormattedText("FPS: "..Glance.Functions.Framerate.formatFPS(GetFramerate()))
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function Glance.Functions.Framerate.tooltip()
	Glance.Debug("function","tooltip","Framerate")
	local func = Glance.Functions.Framerate
	local tooltip = Glance.Functions.Tooltip
	tooltip.Title("Frames Per Second", "GLD")
	tooltip.Double("Current", Glance.Functions.Framerate.formatFPS(Glance.Variables.fps.current),"WHT","GRN")
	tooltip.Double("Minimum", Glance.Functions.Framerate.formatFPS(Glance.Variables.fps.min),"WHT","GRN")
	tooltip.Double("Maximum", Glance.Functions.Framerate.formatFPS(Glance.Variables.fps.max),"WHT","GRN")
	tooltip.Double("Average", Glance.Functions.Framerate.formatFPS(Glance.Variables.fps.avg),"WHT","GRN")
	if ((GetNumPartyMembers() ~= 0 and sender ~= UnitName("player")) or Glance.Variables.Debug) and Glance_Local.Options.sendStats then
		Glance.Functions.addonQuery("Framerate")
		local pty = Glance.Variables.party
		tooltip.Space()
		tooltip.Line("Party", "GLD")
		if pty.a.Framerate ~= 0 then
			tooltip.Double(pty.a.name, pty.a.Framerate, "WHT", "GRN")
		end
		if pty.b.Framerate ~= 0 then
			tooltip.Double(pty.b.name, pty.b.Framerate, "WHT", "GRN")
		end
		if pty.c.Framerate ~= 0 then
			tooltip.Double(pty.c.name, pty.c.Framerate, "WHT", "GRN")
		end
		if pty.d.Framerate ~= 0 then
			tooltip.Double(pty.d.name, pty.d.Framerate, "WHT", "GRN")
		end
	end
end

---------------------------
-- messaging
---------------------------
function Glance.Functions.Framerate.Message()
	return Glance.Functions.Framerate.formatFPS(Glance.Variables.fps.avg)
end

---------------------------
-- fps format function
---------------------------
function Glance.Functions.Framerate.formatFPS(fps)
	local HEX = Glance.Arrays.colors.HEX
	fps = math.floor(fps)
	local sfps
	if fps <= 8 then
		sfps = HEX.red..fps
	elseif fps > 8 and fps < 15 then
		sfps = HEX.yellow..fps
	else
		sfps = HEX.green..fps
	end
	return sfps
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Framerate")
end