
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Friends","LEFT")
local btn = Glance.Buttons.Friends
btn.text              = "Friends"
btn.enabled           = true
btn.events            = {"BN_FRIEND_ACCOUNT_OFFLINE","BN_FRIEND_ACCOUNT_ONLINE","FRIENDLIST_UPDATE"}
btn.update            = true
btn.tooltip           = true
btn.click             = true
btn.save.perCharacter = {}
btn.save.perAccount   = {}

---------------------------
-- update
---------------------------
function Glance.Functions.Friends.update()
	local btn = Glance.Buttons.Friends
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","Friends")
		local HEX = Glance.Arrays.colors.HEX
		local _,WoWFriends = GetNumFriends()
		local _,RealFriends = BNGetNumFriends()
		local friends = "Friends: "..HEX.green..WoWFriends.."/"..RealFriends
		btn.button:SetText(friends)
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function Glance.Functions.Friends.tooltip()
	Glance.Debug("function","tooltip","Friends")
	local tooltip = Glance.Functions.Tooltip
	local HEX = Glance.Arrays.colors.CLASS
	local _,WoWFriends = GetNumFriends()
	local _,RealFriends = BNGetNumFriends()
	tooltip.Line(WoWFriends.." Friend(s) Online","GLD")
	for i = 0, GetNumFriends() do
		local name, level, class, area, connected, status, note = GetFriendInfo(i)
		if connected then
			local cls = string.upper(class)
			tooltip.Double(HEX[cls]..name.." ("..level.." "..class..")", area, "WHT", "WHT")
		end
	end
	tooltip.Space()
	tooltip.Line(RealFriends.." BattleNet Friend(s) Online","GLD")
	for j = 1, BNGetNumFriends() do
		local presenceID, givenName, surname, _,_,_,isOnline = BNGetFriendInfo(j)
		local hasFocus, toonName, client, realmName, realmID, faction, race, class, guild, zoneName, level, gameText, broadcastText, broadcastTime = BNGetToonInfo(presenceID)
		if isOnline then
			local cls = string.upper(class)
			tooltip.Double(givenName.." "..surname, HEX[cls]..toonName.." ("..level.." "..race.." "..class..") |r"..zoneName, "WHT", "WHT")
		end
	end
	tooltip.Space()
	tooltip.Line("(Click to open the Friends tab.)","WHT")
end

---------------------------
-- click
---------------------------
function Glance.Functions.Friends.click(self, button, down)
	Glance.Debug("function","click","Friends")
	if button == "LeftButton" then
		ToggleFriendsFrame(1)
	end
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Friends")
end