
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Latency","LEFT")
local btn = Glance.Buttons.Latency
btn.text              = "Latency"
btn.events            = {}
btn.update            = true
btn.tooltip           = true
btn.timer1            = true
btn.timerTooltip      = true

---------------------------
-- mod variables
---------------------------
Glance.Variables.party.a["Latency"] = 0
Glance.Variables.party.b["Latency"] = 0
Glance.Variables.party.c["Latency"] = 0
Glance.Variables.party.d["Latency"] = 0

---------------------------
-- update
---------------------------
function Glance.Functions.Latency.update()
	local btn  = Glance.Buttons.Latency
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		local HEX = Glance.Arrays.colors.HEX
		local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
		btn.button:SetFormattedText("Lag: "..Glance.Functions.Latency.formatLag(latencyHome).."/"..Glance.Functions.Latency.formatLag(latencyWorld)..HEX.white.." ms")
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end


---------------------------
-- tooltip
---------------------------
function Glance.Functions.Latency.tooltip()
	Glance.Debug("function","tooltip","Latency")
	local func = Glance.Functions.Latency
	local tooltip = Glance.Functions.Tooltip
	local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	tooltip.Title("Latency", "GLD")
	tooltip.Double("Home", func.formatLag(latencyHome).." ms","WHT","GRN")
	tooltip.Double("World", func.formatLag(latencyWorld).." ms","WHT","GRN")
	tooltip.Double("Upload", func.formatBandwidth(bandwidthOut),"WHT","GRN")
	tooltip.Double("Download", func.formatBandwidth(bandwidthIn),"WHT","GRN")
	
	if ((GetNumPartyMembers() ~= 0 and sender ~= UnitName("player")) or Glance.Variables.Debug) and Glance_Local.Options.sendStats then
		Glance.Functions.addonQuery("Latency")
		local pty = Glance.Variables.party
		tooltip.Space()
		tooltip.Double("Party", "Home/World", "GLD", "GLD")
		if pty.a.Latency ~= 0 then
			tooltip.Double(pty.a.name, pty.a.Latency, "WHT", "GRN")
		end
		if pty.b.Latency ~= 0 then
			tooltip.Double(pty.b.name, pty.b.Latency, "WHT", "GRN")
		end
		if pty.c.Latency ~= 0 then
			tooltip.Double(pty.c.name, pty.c.Latency, "WHT", "GRN")
		end
		if pty.d.Latency ~= 0 then
			tooltip.Double(pty.dd.name, pty.d.Latency, "WHT", "GRN")
		end
	end
end

---------------------------
-- messaging
---------------------------
function Glance.Functions.Latency.Message()
	local bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	return Glance.Functions.Latency.formatLag(latencyHome).."/"..Glance.Functions.Latency.formatLag(latencyWorld)
end


---------------------------
-- format lag
---------------------------
function Glance.Functions.Latency.formatLag(input)
	local HEX = Glance.Arrays.colors.HEX
	local lag = input
	local sLag
	if lag >= 350 then
		sLag = HEX.red..lag
	elseif lag < 350 and lag > 200 then
		sLag = HEX.yellow..lag
	else
		sLag = HEX.green..lag
	end
	return sLag
end

---------------------------
-- format lag
---------------------------
function Glance.Functions.Latency.formatBandwidth(input)
	local kb = format("%.2f KB/s", input)
	return kb
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Latency")
end