
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Location","RIGHT")
local btn = Glance.Buttons.Location
btn.text              = "Location"
btn.events            = {}
btn.update            = true
btn.click             = true
btn.timer1            = true


---------------------------
-- update
---------------------------
function Glance.Functions.Location.update()
	local btn  = Glance.Buttons.Location
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		if WorldMapFrame:IsVisible() == nil then
			local HEX = Glance.Arrays.colors.HEX
			local unitx, unity = GetPlayerMapPosition("player")
			local name, subName
			if IsInInstance() then
				name, subName = select(1, GetInstanceInfo()), select(4, GetInstanceInfo())
			else
				name, subName = GetZoneText(), GetSubZoneText()
			end
			if subName ~= "" then
				subName = " - "..subName
			end
			btn.button:SetFormattedText(HEX.darkblue.."%s"..HEX.lightblue.."%s ("..HEX.white.."%d, %d"..HEX.lightblue..")", name, subName, (unitx * 100), (unity * 100))
			btn.button:SetWidth(btn.button:GetTextWidth())
		end
	end
end

---------------------------
-- click
---------------------------
function Glance.Functions.Location.click(self, button, down)
	Glance.Debug("function","click","Location")
	if (button == "LeftButton") then 
		ToggleWorldMap()
	end
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Location")
end