
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Pets","RIGHT")
local btn = Glance.Buttons.Pets
btn.text              = "      "
btn.enabled           = true
btn.texture.normal    = "Interface\\AddOns\\Glance_Pets\\paw.tga"
btn.events            = {"COMPANION_LEARNED"}
btn.update            = true
btn.click             = true
btn.tooltip           = true
btn.menu              = true
btn.options           = true
btn.onload            = true
btn.save.perCharacter = {["Pets"] = {}, ["Favs"] = {}}
btn.save.perAccount   = {}

---------------------------
-- variables
---------------------------
Glance.Arrays.pet = {}
Glance.Arrays.fav = {}
Glance.Arrays.alphabet = {
	["a"] = "ae",
	["b"] = "ae",
	["c"] = "ae",
	["d"] = "ae",
	["e"] = "ae",
	["f"] = "fj",
	["g"] = "fj",
	["h"] = "fj",
	["i"] = "fj",
	["j"] = "fj",
	["k"] = "ko",
	["l"] = "ko",
	["m"] = "ko",
	["n"] = "ko",
	["o"] = "ko",
	["p"] = "pt",
	["q"] = "pt",
	["r"] = "pt",
	["s"] = "pt",
	["t"] = "pt",
	["u"] = "uz",
	["v"] = "uz",
	["w"] = "uz",
	["x"] = "uz",
	["y"] = "uz",
	["z"] = "uz",
}
Glance.Variables.PetScrollIDX = 0
Glance.Variables.PetPanelIDX = 0

---------------------------
-- update
---------------------------
function Glance.Functions.Pets.update(self, event, arg1)
	if event == "COMPANION_LEARNED" then
		Glance.Functions.Pets.resetPetList()
		Glance.Functions.createMenu("Pets")
	end
end


---------------------------
-- tooltip
---------------------------
function Glance.Functions.Pets.tooltip()
	Glance.Debug("function","tooltip","Pets")
	local tooltip = Glance.Functions.Tooltip
	local HEX = Glance.Arrays.colors.HEX
	tooltip.Title("Pets", "GLD")
	tooltip.Line("You have obtained "..HEX.green..GetNumCompanions("CRITTER")..HEX.white.." companion pets.","WHT")
	tooltip.Space()
	tooltip.Wrap("(Click to summon a random pet.)","WHT")
	tooltip.Wrap("(Right-Click to show a dropdown menu of available companion pets for you to select and summon.)","WHT")
end


---------------------------
-- click
---------------------------
function Glance.Functions.Pets.click(self, button, down)
	Glance.Debug("function","click","Pets")
	if button == "LeftButton" then
		SummonRandomCritter()
	end
end


---------------------------
-- onload
---------------------------
function Glance.Functions.Pets.onload()
	Glance.Functions.Pets.resetPetList()
end


---------------------------
-- menu
---------------------------
function Glance.Functions.Pets.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","Pets")
	local HEX = Glance.Arrays.colors.HEX
	level = level or 1
	if (level == 1) then
		Glance.Functions.setInfo(nil,true,false,true,nil,HEX.white.."Pets Options","spacer",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Favorites","favorites",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Pets A-E","ae",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Pets F-J","fj",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Pets K-O","ko",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Pets P-T","pt",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Pets U-Z","uz",level,nil)
		local func = function() DismissCompanion("CRITTER") end;
		Glance.Functions.setInfo(nil,nil,nil,true,nil,HEX.red.."Dismiss Pet","dis",level,func)
	end
	if (level == 2) then
		for i=1,#Glance.Arrays.pet do
			local id, creatureName, icon, issummoned, enabled = unpack(Glance.Arrays.pet[i])
			if Glance.Arrays.alphabet[strlower(string.sub(creatureName,1,1))] == UIDROPDOWNMENU_MENU_VALUE and enabled then
				local checked, func
				checked = Glance.Functions.Pets.isSummoned(i)
				func = function() Glance.Functions.Pets.summon(i); local num = Glance.Buttons.Pets.save.perCharacter.Favs[creatureName] or 0; Glance.Buttons.Pets.save.perCharacter.Favs[creatureName] = num + 1; end;
				Glance.Functions.setInfo(nil,false,false,false,checked,creatureName,name,level,func,icon)
			end
		end
		local count = 1
		for _,kv in ipairs(Glance.Functions.Pets.SortFavs()) do
			for i=1,#Glance.Arrays.pet do
				local id, creatureName, icon, issummoned, enabled = unpack(Glance.Arrays.pet[i])
				if kv.Name == creatureName then
					if UIDROPDOWNMENU_MENU_VALUE == "favorites" and enabled and count <= 10 then
						local checked, func
						checked = Glance.Functions.Pets.isSummoned(i)
						func = function() Glance.Functions.Pets.summon(i); local num = Glance.Buttons.Pets.save.perCharacter.Favs[creatureName] or 0; Glance.Buttons.Pets.save.perCharacter.Favs[creatureName] = num + 1; end;
						Glance.Functions.setInfo(nil,false,false,false,checked,creatureName,name,level,func,icon)
						count = count + 1
					end
				end
			end
		end
	end
end

---------------------------
-- options
---------------------------
function Glance.Functions.Pets.options()
	local pIDX = Glance.Functions.createPanel("Pets","Select which companion pets you wish to be visible on the pets menu.",function(self) Glance.Variables.overflowFix = true end)
	Glance.Variables.PetScrollIDX = Glance.Functions.createScrollBar(_G["Glance_Panel"..pIDX],18,-70,345,378,20,Glance.Arrays.pet,2,5,Glance.Functions.Pets.setPreferredPet)
end

---------------------------
-- pet scrollbar click
---------------------------
function Glance.Functions.Pets.setPreferredPet(line)
	local pref, name
	--for line=1,20 do
		name = _G[getglobal("Glance_SBE"..Glance.Variables.PetScrollIDX..line):GetName().."Text"]:GetText()
		pref = _G["Glance_SBE"..Glance.Variables.PetScrollIDX..line]:GetChecked()
		if pref == 1 then
			pref = true
		else
			pref = false
		end
		if name ~= nil then
			Glance.Buttons.Pets.save.perCharacter.Pets[name] = pref
		end
	--end
	Glance.Functions.Pets.resetPetList()
end
---------------------------
-- is summoned
---------------------------
function Glance.Functions.Pets.isSummoned(id)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", id);
	return issummoned
end

---------------------------
-- summon
---------------------------
function Glance.Functions.Pets.summon(id)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", id);
	if issummoned then
		DismissCompanion("CRITTER")
	else
		CallCompanion("CRITTER",id)
	end
end

---------------------------
-- get pet info
---------------------------
function Glance.Functions.Pets.petInfo(id)
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("CRITTER", id);
	if issummoned == nil then issummoned = false end
	local showPet = true
	if Glance.Buttons.Pets.save.perCharacter.Pets[creatureName] ~= nil then
		showPet = Glance.Buttons.Pets.save.perCharacter.Pets[creatureName]
	end
	return id, creatureName, icon, issummoned, showPet
end

---------------------------
-- store pets in {}
---------------------------
function Glance.Functions.Pets.SortFavs()
	local Sorted = {}
	for k,v in pairs(Glance.Buttons.Pets.save.perCharacter.Favs) do
		table.insert(Sorted, {Name=k, Value=v})
	end
	table.sort(Sorted, function(a,b) return a.Value>b.Value end)
	return Sorted
end

---------------------------
-- store pets in {}
---------------------------
function Glance.Functions.Pets.resetPetList()
	Glance.Debug("function","resetPetList",nil)
	wipe(Glance.Arrays.pet)
	local petListChanged = false
	for i=1,GetNumCompanions("CRITTER") do
		Glance.Arrays.pet[i] = { Glance.Functions.Pets.petInfo(i) }
		if Glance.Buttons.Pets.save.perCharacter.Pets[Glance.Arrays.pet[i][2]] == nil then
			Glance.Buttons.Pets.save.perCharacter.Pets[Glance.Arrays.pet[i][2]] = true
			petListChanged = true
		end
	end
	table.sort(Glance.Arrays.pet, function(a, b) return a[2] < b[2] end)
	if petListChanged then Glance.Functions.sendMSG("Your pet list has changed.") end
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("Pets")
end