
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("TolBarad","LEFT")
local btn = Glance.Buttons.TolBarad
btn.text              = "Tol Barad"
btn.enabled           = true
btn.events            = {""}
btn.update            = true
btn.tooltip           = true
btn.menu              = true
btn.timer1            = true
btn.save.perCharacter = {}
btn.save.perAccount   = { ["ShortName"] = false }

---------------------------
-- variables
---------------------------
Glance.Variables.TBSec = 0

---------------------------
-- update
---------------------------
function Glance.Functions.TolBarad.update(self, event, arg1)
	local btn = Glance.Buttons.TolBarad
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		--Glance.Debug("function","update","Tol Barad")
		local name
		if Glance.Buttons.TolBarad.save.perAccount.ShortName then
			name="TB"
		else
			name="Tol Barad"
		end
		local HEX = Glance.Arrays.colors.HEX
		if WorldMapFrame:IsVisible() == nil then
			local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
			local inInstance, instanceType = IsInInstance()
			if inInstance and instanceType == "raid" then
				if Glance.Variables.TBSec > 0 then
					Glance.Variables.TBSec = Glance.Variables.TBSec - 1
					sec = Glance.Variables.TBSec
				else
					Glance.Variables.TBSec = 0
				end
			else
				Glance.Variables.TBSec = sec
			end
			local control = "|r"
			local area = GetCurrentMapAreaID()
			SetMapByID(708) --708 for tol barad - 485 for wg
			for i = 1, GetNumMapLandmarks() do
				local index = select(3, GetMapLandmarkInfo(i))
				if index == 46 then
					control = Glance.Arrays.colors.FACTION.alliance
				elseif index == 48 then
					control = Glance.Arrays.colors.FACTION.horde
				end
			end
			if not isActive then
				if sec < 60 and sec > 0 then -- 1 minute warning (seconds)
					btn.button:SetFormattedText("%s "..name..": "..HEX.red.."%d|rs", control, (sec or 0))
				elseif sec <= 300 then -- 5 minute warning (minutes)
					btn.button:SetFormattedText("%s "..name..": "..HEX.red.."%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 300 and sec <= 3600 then -- show minutes
					btn.button:SetFormattedText("%s "..name..": "..HEX.green.."%d|rm", control, (math.floor(sec/60) or 0))
				elseif sec > 3600 then -- show hours
					local hour, min
					hour = (math.floor(sec/3600) or 0)
					min	= (math.floor((sec-(hour*3600))/60) or 0)
					btn.button:SetFormattedText("%s "..name..": "..HEX.green.."%d|rh "..HEX.green.."%d|rm", control, hour, min)
				end
			else -- in session
				btn.button:SetFormattedText(name..": "..HEX.red.."0|rm")
			end
			SetMapByID(area)
		end
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
end

---------------------------
-- tooltip
---------------------------
function Glance.Functions.TolBarad.tooltip()
	Glance.Debug("function","tooltip","Tol Barad")
	local tooltip = Glance.Functions.Tooltip
	local HEX = Glance.Arrays.colors.HEX
	tooltip.Title("Tol Barad", "GLD")
	local area = GetCurrentMapAreaID()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
	local inInstance, instanceType = IsInInstance()
	local control = "|r"
	SetMapByID(708) --708 for tol barad
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = Glance.Arrays.colors.FACTION.alliance.."Alliance"
		elseif index == 48 then
			control = Glance.Arrays.colors.FACTION.horde.."Horde"
		end
	end
	if not isActive then
		if (control=="|r") then
			tooltip.Line("|rControl of "..localizedName.." cannot be determined.", "WHT")
			tooltip.Line("|rYou must be in Tol Barad at least once this session.", "WHT")
		else
			tooltip.Line("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		tooltip.Line("|rThe battle for "..localizedName.." is in progress.", "WHT")
	end
	SetMapByID(area)
end

---------------------------
-- menu
---------------------------
function Glance.Functions.TolBarad.menu(level,UIDROPDOWNMENU_MENU_VALUE)
	Glance.Debug("function","menu","TolBarad")
	local HEX = Glance.Arrays.colors.HEX
	level = level or 1
	if (level == 1) then
		Glance.Functions.setInfo(nil,true,false,true,nil,HEX.white.."TolBarad Options","spacer",level,nil)
		Glance.Functions.setInfo(nil,nil,true,true,nil,HEX.gold.."Use Short Names (TB)","ShortName",level,nil)
	end
	if (level == 2) then
		if UIDROPDOWNMENU_MENU_VALUE == "ShortName" then
			local checked, func
			if Glance.Buttons.TolBarad.save.perAccount.ShortName then checked = true else checked = false end
			func = function() Glance.Buttons.TolBarad.save.perAccount.ShortName=true; Glance.Functions.TolBarad.update() end;
			--disabled,isTitle,hasArrow,notCheckable,checked,text,value,level,func
			Glance.Functions.setInfo(nil,false,false,false,checked,"On","On",level,func)
			if Glance.Buttons.TolBarad.save.perAccount.ShortName then checked = false else checked = true end
			func = function() Glance.Buttons.TolBarad.save.perAccount.ShortName=false; Glance.Functions.TolBarad.update() end;
			Glance.Functions.setInfo(nil,false,false,false,checked,"Off","Off",level,func)
		end
	end
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("TolBarad")
end