
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("XP","LEFT")
local btn = Glance.Buttons.XP
btn.text              = "XP"
btn.enabled           = true
btn.events            = {"PLAYER_LEVEL_UP","CHAT_MSG_COMBAT_XP_GAIN","QUEST_COMPLETE","PLAYER_XP_UPDATE"}
btn.update            = true
btn.tooltip           = true
btn.save.perCharacter = {["xp"] = {["kills2level"] = 0,["quests2level"] = 0,["gathers2level"] = 0,}}
btn.save.perAccount   = {}


---------------------------
-- variables
---------------------------
Glance.Variables.party.a["XP"] = 0
Glance.Variables.party.b["XP"] = 0
Glance.Variables.party.c["XP"] = 0
Glance.Variables.party.d["XP"] = 0
Glance.Variables["xp"] = {
	["level"] = 0,
	["cap"] = 0,
	["accumulated"] = 0,
	["current"] = 0,
	["currentPCT"] = 0,
	["init"] = UnitXP("player"),
	["needed"] = 0,
	["neededPCT"] = 0,
	["rested"] = 0,
	["restedPCT "] = 0,
	["session"] = 0,
	["sessionPCT"] = 0,
	["xpersec"] = 0,
	["xperhour"] = 0,
	["leveltime"] = 0,
	["petlevel"] = 0,
	["petcap"] = 0,
	["petcurrent"] = 0,
	["petcurrentPCT"] = 0,
	["petneeded"] = 0,
	["petneededPCT"] = 0,
	["kills2level"] = 0,
	["quests2level"] = 0,
	["gathers2level"] = 0,
	["questCompleteOpen"] = false,
	["kills"] = {
		["avg"] = 0,
		["current"] = 0,
		["min"] = 0,
		["max"] = 0,
		["count"] = 0,
	},
	["quests"] = {
		["avg"] = 0,
		["current"] = 0,
		["min"] = 0,
		["max"] = 0,
		["count"] = 0,
	},
	["gathers"] = {
		["avg"] = 0,
		["current"] = 0,
		["min"] = 0,
		["max"] = 0,
		["count"] = 0,
	},
}


---------------------------
-- update
---------------------------
function Glance.Functions.XP.update(self, event, arg1)
	local btn = Glance.Buttons.XP
	local HEX = Glance.Arrays.colors.HEX
	if btn.enabled and Glance.Variables.loaded then -- loaded keeps it from launching when defined
		Glance.Debug("function","update","XP")
		if UnitLevel("player") < 85 then
			Glance.Functions.XP.set()
			btn.button:SetText("XP: "..HEX.green..Glance.Variables.xp.currentPCT.."%")
		else
			btn.button:SetText("XP: "..HEX.green.."max")
		end
		btn.button:SetWidth(btn.button:GetTextWidth())
	end
	if (event == "CHAT_MSG_COMBAT_XP_GAIN") then
		Glance.Functions.XP.onChatXPGain(arg1)
	elseif (event == "QUEST_COMPLETE") then
		Glance.Variables.xp.questCompleteOpen = true
	elseif (event == "PLAYER_LEVEL_UP") then
		Glance.Variables.xp.accumulated = Glance.Variables.xp.accumulated + UnitXPMax("player") - Glance.Variables.xp.init
		Glance.Variables.xp.init = 0
		Glance.Variables.gametime.initLevel = time()
	elseif (event == "PLAYER_XP_UPDATE") then
		--Glance.Functions.addonQuery("GlanceQuery","xperhour")
	end
end


---------------------------
-- tooltip
---------------------------
function Glance.Functions.XP.tooltip()
	Glance.Functions.XP.set()
	Glance.Debug("function","tooltip","XP")
	local HEX = Glance.Arrays.colors.HEX
	local tooltip = Glance.Functions.Tooltip
	local gti = Glance.Variables.gametime
	local var = Glance.Variables.xp
	
	if var.level < 85 then
		tooltip.Title("Experience", "GLD")
		tooltip.Double("Total XP Required This Level ("..var.level.." to "..(var.level+1)..")", var.cap,"WHT", "GRN")
		tooltip.Double("XP Gained This Level ", "("..var.currentPCT.."%) "..var.current, "WHT", "GRN")
		tooltip.Double("XP Needed To Level ", "("..var.neededPCT.."%) "..var.needed,"WHT", "GRN")
		if var.rested > 0 then
			tooltip.Double("Rested XP ", "("..var.restedPCT.."%) "..var.rested, "BLU", "GRN")
		else
			tooltip.Double("Rested XP ", "("..var.restedPCT.."%) "..var.rested, "PPL", "RED")
		end
	end
	
	if var.level == 85 then
		tooltip.Title("Game Time", "GLD")
	else
		tooltip.Space()
		tooltip.Line("Game Time", "GLD")
	end
	tooltip.Double("Total Time Played", Glance.Functions.formatTime(gti.total), "WHT", "GRN")
	tooltip.Double("Time Played This Level ", Glance.Functions.formatTime(gti.level), "WHT", "GRN")
	tooltip.Double("Time Played This Session ", Glance.Functions.formatTime(gti.session), "WHT", "GRN")
	
	if var.level < 85 then
		if var.xperhour ~= 0 then
			tooltip.Space()
			tooltip.Line("Leveling Speed", "GLD")
			tooltip.Double("XP/Hour ", var.xperhour, "WHT", "GRN")
			tooltip.Double("Time To Level",  Glance.Functions.formatTime(var.leveltime), "WHT", "GRN")
		end
		tooltip.Space()
		tooltip.Line("Leveling Stats", "GLD")
		tooltip.Double("Kills To Level (avg "..var.kills.avg.." xp)", var.kills2level, "WHT", "GRN")
		tooltip.Double("Quests To Level (avg "..var.quests.avg.." xp)", var.quests2level, "WHT", "GRN")
		tooltip.Double("Gathers To Level (avg "..var.gathers.avg.." xp)", var.gathers2level, "WHT", "GRN")
	end
	
	-- if Glance.Variables.Debug then
		-- tooltip.Space()
		-- tooltip.Line("currentxp - initxp + accumulatedxp = sessionxp", "GLD")
		-- tooltip.Line(var.current.." - "..var.init.." + "..var.accumulated.." = "..var.session, "WHT")
		
		-- tooltip.Space()
		-- tooltip.Line("sessionxp/sessiontime = xpersec", "GLD")
		-- tooltip.Line(var.session.."/"..gti.session.." = "..var.xpersec, "WHT")
		
		-- tooltip.Space()
		-- tooltip.Line("xpersec*3600 = xperhour", "GLD")
		-- tooltip.Line(var.xpersec.."*3600 = "..var.xperhour, "WHT")
		
		-- tooltip.Space()
		-- tooltip.Line("neededxp/xpersec = leveltime", "GLD")
		-- tooltip.Line(var.needed.."/"..var.xpersec.." = "..var.leveltime, "WHT")
	-- end
	
	if var.petcap ~= 0 then
		tooltip.Space()
		tooltip.Double("Hunter Pet (Level)", "XP", "GLD", "GLD")
		tooltip.Double(UnitName("pet").." ("..HEX.green..var.petlevel..HEX.white..") ", var.petcurrent.."/"..var.petcap.." ("..var.petcurrentPCT.."%)","WHT", "GRN")
	end
	
	if ((GetNumPartyMembers() ~= 0 and sender ~= UnitName("player")) or Glance.Variables.Debug) and Glance_Local.Options.sendStats then
		Glance.Functions.addonQuery("XP")
		local pty = Glance.Variables.party
		tooltip.Space()
		tooltip.Double("Party (Level) (Level%)", "XP/Hour", "GLD", "GLD")
		local xph,cpct = strsplit("*", pty.a.XP)
		if pty.a.XP ~= 0 then
			tooltip.Double(pty.a.name.." ("..HEX.green..UnitLevel(pty.a.name)..HEX.white..") ("..HEX.green..cpct.."%"..HEX.white..")", xph, "WHT", "GRN")
		end
		if pty.b.XP ~= 0 then
			xph,cpct = strsplit("*", pty.b.XP)
			tooltip.Double(pty.b.name.." ("..HEX.green..UnitLevel(pty.b.name)..HEX.white..") ("..HEX.green..cpct.."%"..HEX.white..")", xph, "WHT", "GRN")
		end
		if pty.c.XP ~= 0 then
			xph,cpct = strsplit("*", pty.c.XP)
			tooltip.Double(pty.c.name.." ("..HEX.green..UnitLevel(pty.c.name)..HEX.white..") ("..HEX.green..cpct.."%"..HEX.white..")", xph, "WHT", "GRN")
		end
		if pty.d.XP ~= 0 then
			xph,cpct = strsplit("*", pty.d.XP)
			tooltip.Double(pty.d.name.." ("..HEX.green..UnitLevel(pty.d.name)..HEX.white..") ("..HEX.green..cpct.."%"..HEX.white..")", xph, "WHT", "GRN")
		end
	end
end

---------------------------
-- messaging
---------------------------
function Glance.Functions.XP.Message()
	return Glance.Variables.xp.xperhour.."*"..Glance.Variables.xp.currentPCT
end


---------------------------
-- set xp vars
---------------------------
function Glance.Functions.XP.set()
	local gti = Glance.Variables.gametime
	gti.session = time() - gti.initSession
	gti.total   = time() - gti.initTotal
	gti.level   = time() - gti.initLevel
	
	local var = Glance.Variables.xp
	var.level         = UnitLevel("player")
	var.cap           = UnitXPMax("player")
	var.current       = UnitXP("player")
	var.currentPCT    = Glance.Functions.getPCT(var.current,var.cap)
	var.needed        = var.cap - var.current
	var.neededPCT     = 100-var.currentPCT
	var.rested        = GetXPExhaustion() or 0
	var.restedPCT     = Glance.Functions.getPCT(var.rested,var.cap)
	var.session       = var.current - var.init + var.accumulated
	var.sessionPCT    = Glance.Functions.getPCT(var.session,var.cap)
	var.xpersec       = (var.session/gti.session) or 0
	var.xperhour      = math.ceil(var.xpersec*3600) or 0
	if var.xpersec == 0 then
		var.leveltime = 0
	else
		var.leveltime = math.ceil(var.needed/var.xpersec)
	end
	if var.kills.avg ~= 0 then
		var.kills2level = math.ceil(var.needed/var.kills.avg) 
		Glance.Buttons.XP.save.perCharacter.xp.kills2level = var.kills2level
	else 
		var.kills2level = Glance.Buttons.XP.save.perCharacter.xp.kills2level or 0
	end
	if var.quests.avg ~= 0 then
		var.quests2level  = math.ceil(var.needed/var.quests.avg)
		Glance.Buttons.XP.save.perCharacter.xp.quests2level = var.quests2level
	else
		var.quests2level = Glance.Buttons.XP.save.perCharacter.xp.quests2level or 0
	end
	if var.gathers.avg ~= 0 then
		var.gathers2level = math.ceil(var.needed/var.gathers.avg)
		Glance.Buttons.XP.save.perCharacter.xp.gathers2level = var.gathers2level
	else
		var.gathers2level = Glance.Buttons.XP.save.perCharacter.xp.gathers2level or 0
	end
	var.petlevel      = UnitLevel("pet")
	var.petcap        = select(2,GetPetExperience()) or 0
	var.petcurrent    = select(1,GetPetExperience()) or 0
	var.petcurrentPCT = Glance.Functions.getPCT(var.petcurrent,var.petcap)
	var.petneeded     = var.petcap-var.petcurrent or 0
	var.petneededPCT  = Glance.Functions.getPCT(var.petneeded,var.petcap)
	Glance.Buttons.XP.save.perCharacter.xp.kills2level   = var.kills2level
	Glance.Buttons.XP.save.perCharacter.xp.quests2level  = var.quests2level
	Glance.Buttons.XP.save.perCharacter.xp.gathers2level = var.gathers2level
end


---------------------------
-- on chat xp event
---------------------------
function Glance.Functions.XP.onChatXPGain(message)
    local xp, mobName = Glance.Functions.XP.parseChatMessage(message)
    xp = tonumber(xp)
	if not xp then
		return false
	end	
    if mobName ~= nil then
		Glance.Functions.stats(Glance.Variables.xp.kills,xp)
    else
		if Glance.Variables.xp.questCompleteOpen then
			Glance.Functions.stats(Glance.Variables.xp.quests,xp)
			Glance.Variables.xp.questCompleteOpen = false
		else
			Glance.Functions.stats(Glance.Variables.xp.gathers,xp)
		end
	end
end

---------------------------
-- regex chat log
---------------------------
function Glance.Functions.XP.parseChatLog(isQuest)
	local inInstance, itype = IsInInstance()
	local inGroup =  GetNumPartyMembers() > 0
	local regex = nil
	local isRested = GetXPExhaustion()
	if not isQuest then
		if inInstance and isRested then
			if itype == "party" and inGroup then
				regex = COMBATLOG_XPGAIN_EXHAUSTION1_GROUP
			elseif itype == "raid" and inGroup then
				regex = COMBATLOG_XPGAIN_EXHAUSTION1_RAID
			else
				regex = COMBATLOG_XPGAIN_EXHAUSTION1
			end
		elseif inInstance and not isRested then
			if itype == "party" and inGroup then
				regex = COMBATLOG_XPGAIN_FIRSTPERSON_GROUP
			elseif itype == "raid" and inGroup then
				regex = COMBATLOG_XPGAIN_FIRSTPERSON_RAID
			else
				regex = COMBATLOG_XPGAIN_FIRSTPERSON
			end
		else
			if isRested then
				regex = COMBATLOG_XPGAIN_EXHAUSTION1
			else
				regex = COMBATLOG_XPGAIN_FIRSTPERSON
			end
		end
	else
		regex = COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED
	end
	regex = string.gsub(regex, "%(", "%%(")
	regex = string.gsub(regex, "%)", "%%)")
	regex = string.gsub(regex, "%+", "%%+")
	regex = string.gsub(regex, "%-", "%%-")
	regex = string.gsub(regex, "%%%d?%$?s", "(.+)")
	regex = string.gsub(regex, "%%%d?%$?d", "(%%d+)")
	return regex
end

---------------------------
-- parse chat log
---------------------------
function Glance.Functions.XP.parseChatMessage(message)
	local isQuest = string.find(message, ",") == nil
	local pattern = Glance.Functions.XP.parseChatLog(isQuest)
	local mob, xp = strmatch(message, pattern);
	if tonumber(mob) then
		xp = tonumber(mob)
		mob = nil
	end	
	return xp, mob;
end

---------------------------
-- load on demand
---------------------------
if Glance.Variables.loaded then
	Glance.Functions.Enable("XP")
end